#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <string.h>
#include "sac.h"
#include "regexp.h"

#define READ_DATA 1
#define FLDLEN 4
#define STALEN 8
#define CHALEN 8
#define NETLEN 8
#define MAXLINELEN 1024

#define MAX(a,b) ((a) >= (b) ? (a) : (b))
#define MIN(a,b) ((a) <= (b) ? (a) : (b))
#define ABS(a) ((a) >= 0 ? (a) : -(a))

double pi;
double rad_per_deg;

#define UBYTE unsigned char
#define UBYTE2 unsigned short

typedef struct _BTIME {
    UBYTE2 year;           /* e.g. 1991 */
    UBYTE2 day;            /* 1..366 */
    UBYTE hours;          /* 0..23 */
    UBYTE minutes;        /* 0..59 */
    UBYTE seconds;        /* 0..59, 60 for leap */
    UBYTE alignment_1;
    UBYTE2 frac_secs;      /* 0.0001 seconds, 0..9999 */
} BTIME;

struct evalresp_args {
    char  sta[STALEN];
    char  chan[CHALEN];
    char  net[NETLEN];
    int   year;
    int   jday;
    int   hour;
    int   min;
    float sec;
    float min_freq;
    float max_freq;
    int   nfreqs;
    char  units[FLDLEN];
    char  resp_type[FLDLEN];
    char  spacing[FLDLEN];
    char  resp_file[MAXLINELEN];
};

int read_sac(FILE *, int, struct sac *, float **);
int write_sac(FILE *, struct sac *, float *);
char *get_netcode(char *);
int get_float(char *, char *, float *);
void epoch2btime(BTIME *, double);
double btime2epoch(BTIME *);
int is_leap(UBYTE2);
float get_mean(float *, int);
int string_match(char *, char *);
int find_north(int, int);
